Skip to main content

Greedy Algorithm - Question 2

300. Longest Increasing Subsequence

Given an integer array nums, return the length of the longest strictly increasing subsequence.

A subsequence is a sequence that can be derived from an array by deleting some or no elements without changing the order of the remaining elements. For example, [3,6,2,7] is a subsequence of the array [0,3,1,6,2,2,7].

Constraints:

1 <= nums.length <= 2500

-10^4 <= nums[i] <= 10^4


Follow up: Can you come up with an algorithm that runs in O(n log(n)) time complexity?


Analysis:

This questions can be solved by dynamic programming (dp) with a time complexity of O(N^2), where N is the length of the array. The key point is to define dp[i] as the longest length of the increasing sequence ending with element arr[i].

The pseudo code is:

for(int i=0; i<n; ++i) {
    for(int j=0; j<i; ++j) {
        if(arr[i] > arr[j]) dp[i] = max(dp[i], dp[j] + 1);
    }
    res = max(res, dp[i]);
}

The time complexity is O(N^2), which is not the optimal solution.

The optimal solution is using the so-called patient algorithm. The basic idea to maintain some decreasing sequences. And for each new element arr[i], we need to search for the position of it. The rule is to find the first sequences with an ending elements larger or equal to arr[i].

If the ending element is larger than arr[i], then we just place arr[i] after it as the new ending element;

If the ending element is equal to arr[i], nothing needs to do;

If arr[i] is larger than all the ending elements, then we need to create a new sequence with arr[i] as the first element (which is the ending element for the new sequence as well).

In this way, the ending elements is monotonically increasing. And the number of the sequences is the length of the longest increasing sub-sequence.

So we can use binary search to find the position to place the new element, or create a new sequence.

Now let us focus on the reason why this greedy method work.

Maybe it is relative easier to understand this with an example. Let say we have one array: [9, 10, 1, 2, 4, 11, 23, 20, 3].

The first element is 9, so we need to create a sequence [[9]];

The next element is 10, so we need to create a second one [[9], [10]].

When i = 2, the sequences becomes [[9, 1], [10]];

                3,                                       [[9, 1], [10, 2]]

                4,                                        [[9, 1], [10, 2], [4]]

                5,                                        [[9, 1], [10, 2], [4], [11]]

                6,                                        [[9, 1], [10, 2], [4], [11], [23]] 

                7,                                        [[9, 1], [10, 2], [4], [11], [23, 20]]

                8,                                        [[9, 1], [10, 2], [4,3], [11], [23, 20]]

The number of the sequences is 5, which is correct (1, 2, 4, 11, 23, or 1, 2, 4, 11, 20).

Then why the element of 1 can be greedily placed after 9? The reason is that element 1 appears later than 9, and also smaller than 9. So if there is any element after element 1 larger than 9, it would larger than 1 as well! Thus, keep 1 as the ending element rather than 9 would not miss any potentially longer increasing subsequence. 

This argument applies to every new element to be placed into the sorted sub-sequences.

One observation is that: the ending elements are sorted, for example in the above case, it is [1, 2, 3, 11, 20]. But the ending-element-sequence is not necessary as an valid solution (the solution to the above case is [1, 2, 4, 11, 23] or [1, 2, 4, 11, 20]). But the length is the same!

A different way to understand this method is that: the first element in an valid solution must be in the first sequence; the second is in the second sequence; ..., the nth is in the nth sequence, even though the sequences of all the ending elements of each sequence is not necessarily an valid solution. That is why the length is always the same, which is what we need for this question.

Since we just need the ending elements, we can maintain one single array called tails, which are the collections of the ending elements from the above sequences. When a new element arr[i] arrive, we just need to find a position for arr[i], using the same rules as the above: find the first element that is larger or equal to arr[i]. If exist, use arr[i] to replace it; if not, add arr[i] in the back.

After handling all the elements, the length of the array is the answer.


See the code below:


class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        vector<int> tails;
        for(auto &a : nums) {
            auto it = lower_bound(tails.begin(), tails.end(), a);
            if(it == tails.end()) tails.push_back(a);
            else *it = a;
        }
        return tails.size();
    }
};


Follow up 1: how about the length of the longest non-decreasing sub-sequence? For example, [2, 2, 2, 2]. The above method is for increasing sub-sequence, which generates 1. But if asks for non-decreasing, the answer should be 4.

We just need to change one place in the above code: from lower_bound to upper_bound.

See the code below:

class Solution {
public:
    int lengthOfLNDS(vector<int>& nums) {
        vector<int> tails;
        for(auto &a : nums) {
            auto it = upper_bound(tails.begin(), tails.end(), a);
            if(it == tails.end()) tails.push_back(a);
            else *it = a;
        }
        return tails.size();
    }
};


Follow up 2: Say we have one array, and we want to make the array sorted by decreasing some elements. What is the minimum number of elements to be deleted, to make the remained array sorted?

This question is essentially the same as the LIS question!




Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once. We

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3 878. Nth Magical Number A positive integer is magical if it is divisible by either a or b. Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7. Analysis: Let us consider some examples first. Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b; Example 2, a = 3, b = 2. The multiples of 2 are: 2, 4, 6, 8, 10, 12, ... The multiple of 3 are: 3, 6, 9, 12, ... So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted. So now, we make some conclusions: 1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a); 2. there are n*b/a magical numbers smaller than n*b; 3. there are n*b/(minimum common multiple) overlaps. Thus, the overall count is: n +

Recursion - Example

Recursion - Example Leetcode 231  Power of Two Given an integer n, return true if it is a power of two. Otherwise, return false. An integer n is a power of two, if there exists an integer x such that n == 2^x Constraints: -2^31 <= n <= 2^31 - 1 Analysis: One way is to think about this question recursively: if n%2 == 1, then n must not be power of 2; if not, then we just need to consider whether (n/2) is a power of 2 or not. This is exactly the "same question with a smaller size"! It is trivial to figure out the base cases: if n == 0, return false; if n == 1, return true. See the code below: class Solution { public: bool isPowerOfTwo(int n) { // base cases if(n == 0) return false; if(n == 1) return true; // converging if(n%2 == 1) return false; return isPowerOfTwo(n/2); } }; If interested, there are some other ways to solve this problem. For example, using bit manipulation, we can have the following solution: class